<?php
include_once("test_common.php");

$q = 0;
function amfphp_serialize_callback($d,$event)
{
	if($event != AMFE_MAP)
	{
		echo "Not handled event $event\n";
		return;
	}
	global $q;
	if(is_resource($d))
	{
		echo("resource callback for $q\n");
		$q = $q + 1 ;
		return array(array("hay resource".$q), AMFC_ANY);
	}
 	$classname = get_class($d);
    echo("classname callback $classname\n");
}

function amfphp_unserialize_callback($event, $arg)
{
        switch($event)
        {
        case AMFE_MAP:
            $classname = $arg;
            if($classname == "My.Custom.Clazz")
                return new CustomClass();
            else
                return new $classname();
        }
}

$testdump = 1;
$array = 'a:23:{s:13:"connectParams";a:3:{s:11:"description";s:96:"Creates a connection based on my parameters\nOne becomes what one is...\n\nSee also my dingaling";s:9:"arguments";a:3:{i:0;s:4:"host";i:1;s:4:"user";i:2;s:8:"password";}s:6:"access";s:7:"private";}s:7:"connect";a:3:{s:11:"description";s:23:"Connect to the database";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:12:"simple_login";a:3:{s:11:"description";s:79:"Simple login by judah. Using preventative code against a mysql injection attack";s:9:"arguments";a:3:{i:0;s:4:"user";i:1;s:8:"password";i:2;s:4:"md_5";}s:6:"access";s:6:"remote";}s:13:"simple_select";a:3:{s:11:"description";s:39:"Simple select. Where clause is optional";s:9:"arguments";a:3:{i:0;s:3:"get";i:1;s:5:"table";i:2;s:5:"where";}s:6:"access";s:6:"remote";}s:23:"simple_select_with_join";a:3:{s:11:"description";s:49:"Simple select with join. Where clause is optional";s:9:"arguments";a:4:{i:0;s:3:"get";i:1;s:5:"table";i:2;s:5:"where";i:3;s:8:"add_join";}s:6:"access";s:6:"remote";}s:5:"query";a:3:{s:11:"description";s:22:"Process a manual query";s:9:"arguments";a:1:{i:0;s:9:"the_query";}s:6:"access";s:6:"remote";}s:10:"exec_query";a:3:{s:11:"description";s:77:"Executes passes SQL query. Executes non returning query for delete or update.";s:9:"arguments";a:1:{i:0;s:4:"sSql";}s:6:"access";s:6:"remote";}s:9:"do_insert";a:3:{s:11:"description";s:13:"Insert method";s:9:"arguments";a:2:{i:0;s:3:"tbl";i:1;s:3:"arr";}s:6:"access";s:6:"remote";}s:13:"simple_delete";a:3:{s:11:"description";s:76:"Simple delete. Where parameter is optional. simple_delete( \'table\', \'id=1\' )";s:9:"arguments";a:2:{i:0;s:3:"tbl";i:1;s:5:"where";}s:6:"access";s:6:"remote";}s:9:"do_update";a:3:{s:11:"description";s:43:"Update method. Where parameter is optional.";s:9:"arguments";a:3:{i:0;s:3:"tbl";i:1;s:3:"arr";i:2;s:5:"where";}s:6:"access";s:6:"remote";}s:13:"simple_update";a:3:{s:11:"description";s:58:"Simple update. Where and priority parameters are optional.";s:9:"arguments";a:4:{i:0;s:3:"tbl";i:1;s:3:"set";i:2;s:5:"where";i:3;s:7:"low_pro";}s:6:"access";s:6:"remote";}s:15:"get_table_names";a:3:{s:11:"description";s:25:"Return an array of tables";s:9:"arguments";a:1:{i:0;s:10:"dummyparam";}s:6:"access";s:6:"remote";}s:9:"fetch_row";a:3:{s:11:"description";s:35:"Fetch a row based on the last query";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:16:"fetch_row_object";a:3:{s:11:"description";s:50:"Fetch a row based on the last query in Object form";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:17:"get_affected_rows";a:3:{s:11:"description";s:51:"Fetch the number of rows affected by the last query";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:12:"get_num_rows";a:3:{s:11:"description";s:40:"Fetch the number of rows in a result set";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:13:"get_insert_id";a:3:{s:11:"description";s:50:"Fetch the last insert id from an sql autoincrement";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:11:"free_result";a:3:{s:11:"description";s:38:"Free the result set from mySQLs memory";s:9:"arguments";a:1:{i:0;s:9:"recordset";}s:6:"access";s:7:"private";}s:17:"get_result_fields";a:3:{s:11:"description";s:25:"Return an array of fields";s:9:"arguments";a:1:{i:0;s:9:"recordset";}s:6:"access";s:7:"private";}s:8:"close_db";a:3:{s:11:"description";s:22:"Shut down the database";s:9:"arguments";a:0:{}s:6:"access";s:7:"private";}s:11:"fatal_error";a:3:{s:11:"description";s:21:"No description given.";s:9:"arguments";a:1:{i:0;s:9:"the_error";}s:6:"access";s:7:"private";}s:24:"compile_db_insert_string";a:3:{s:11:"description";s:36:"Compiles SQL formatted insert fields";s:9:"arguments";a:1:{i:0;s:4:"data";}s:6:"access";s:7:"private";}s:24:"compile_db_update_string";a:3:{s:11:"description";s:163:"Compiles SQL formatted update fields Creates an array from a multidimensional array returning a formatted string The data param is an array of field => value pairs";s:9:"arguments";a:1:{i:0;s:4:"data";}s:6:"access";s:7:"private";}}';
$w = unserialize($array);
$h = amf_encode($w,AMF_AMF3);
//echo($h);
//echo(strhex($h));
//var_dump(amf_decode($h));
//test($array);
?>